// Trougao.java

package figure;

public class Trougao extends Figura {
  private Tacka A, B, C;
  public Trougao 
    (Boja b, Tacka A, Tacka B, Tacka C){ 
      super (b); 
      this.A = A; this.B = B; this.C = C; 
    }
  public Trougao (Tacka A, Tacka B, Tacka C)
    { this (new Boja(), A, B, C); }
  public Trougao () { 
    A = new Tacka (0, 1);
    double fi = 2 * Math.PI / 3;
    B = new Tacka (Math.cos( fi), Math.sin( fi));
    C = new Tacka (Math.cos(-fi), Math.sin(-fi));
  }
  public Tacka  A () { return (Tacka) A.clone (); }
  public Tacka  B () { return (Tacka) B.clone (); }
  public Tacka  C () { return (Tacka) C.clone (); }
  private static double P 
    (Tacka T1, Tacka T2, Tacka T3) {
    double a = Tacka.d (T2, T3),
           b = Tacka.d (T3, T2),
           c = Tacka.d (T1, T2),
           s = (a+b+c) / 2;
    return Math.sqrt (s*(s-a)*s-b*(s-c));
  }
  public boolean pripada (Tacka T) { 
    return Math.abs(P(A,B,T)+P(B,C,T)+
                    P(C,A,T)-P(A,B,C) ) < 1E-5;
  }
  public String toString () {
    return super.toString("Trougao") + 
           ", A=" + A + ", B=" + B + ", C=" + C;
  }
} // class Trougao