// Figuret.java

import figure.*;
import usluge.*;

public class Figuret {
  private static Figura citaj (int nivo) {
    String r = "";
    for (int i=0; i<nivo; i++) r += "  ";
    while (true) try {
      System.out.print (r + "Vrsta figure? ");
      String vrsta = Citaj.String ();
      if (vrsta.equals ("pravougaonik")) {
        System.out.print (r + "Donje levo teme?   ");
        Tacka A = Tacka.citaj();
        System.out.print (r + "Gornje desno teme? ");
        Tacka B = Tacka.citaj();
        System.out.print (r + "Boja? ");
        Boja b = Boja.citaj();
        return new Pravougaonik (b, A, B);
      } else if (vrsta.equals ("crtez")) {
        System.out.print (r + "Donje levo teme? ");
        double x = Citaj.Double (),
               y = Citaj.Double ();
        System.out.print (r + "Sirina i visina? ");
        double sir = Citaj.Double (),
               vis = Citaj.Double ();
        System.out.print (r + "Boja? ");
        Boja b = Boja.citaj();
        Crtez crtez = new Crtez (b, x, y, sir, vis);
        while (true) {
          Figura f = citaj (nivo+1);
          if (f == null) break;
          crtez.dodaj (f);
        }
        return crtez;
      } else {
        return null;
      }
    } catch (Greska g) { System.out.println (g); }
  }
  public static void main (String[] varg) {
    Crtez crtez = 
      new Crtez (Boja.PLAVA, 100, 100, 600, 400);
    while (true) {
      Figura f = citaj (0);
    if (f == null) break;
      crtez.dodaj (f);
    }
    System.out.println (crtez);
    while (true) {
      System.out.print ("Tacka? ");
      Tacka T = new Tacka ().citaj ();
    if (T.x() == 1E38) break;
      try {
        System.out.println ("Boja=" + crtez.boja(T));
      } catch (GTackaNePripadaFiguri g) {
        System.out.println (g);
      }
    }
  }
} // class FigureT
