// Figura.java

package figure;

public abstract class Figura {
  private static int ukId;
  private int id = ++ukId;
  private Boja boja;
  public Figura (Boja b) { boja = b; }
  public Figura () { boja = new Boja (); }
  public int id () { return id; }
  public abstract boolean pripada (Tacka t);
  public final Boja boja () { return boja; }
  public Boja boja (Tacka t) 
    throws GTackaNePripadaFiguri {
    if (! pripada (t)) 
      throw new GTackaNePripadaFiguri (t, this);
    return boja;
  }
  public String toString () 
    { return Integer.toString (id); }
  public String toString (String vrsta) {
    return vrsta + ": id=" + id() + 
           ", boja=" + boja();
  }
} // class Figura