// Kupac.java - Kupac samoposluge.

package samoposluga;

class Kupac extends Thread {

  private static int ukId = 0;
  private int maxKupovina, id=++ukId;
  private Samoposluga samoposl;

  Kupac (Samoposluga samop, int maxKup) {
    samoposl = samop;
    maxKupovina = maxKup;
    start ();
  }

  public void run () {
    try { sleep ((long) (Math.random () * maxKupovina)); } 
      catch (InterruptedException e) {}
    Kasa[] kase = samoposl.dohvatiKase ();
    Kasa kasa = kase[(int)(Math.random()*kase.length)];
    kasa.staviURed (this);
    synchronized (this) {
      try { wait (); } catch (InterruptedException e) {}
    }
    samoposl.izasaoKupac ();
  }
  
  synchronized void naplaceno () { notify (); }

  int id () { return id; }

} // class Kupac
