// Potrosac.java - Klasa za potrosace.

package skladista;
import usluge.Polje; // Veza sa grafickom povrsom.

public class Potrosac extends Thread {
  private static volatile int ukId = 0;
  private Skladiste skladiste;
  private int id=++ukId, minVreme, maxVreme, broj;
  private Polje polje;

  public Potrosac (Skladiste sklad,
    int minVr, int maxVr, Polje p) { 
    minVreme = minVr; maxVreme = maxVr; 
    skladiste = sklad; polje = p;
  }
  public Potrosac (Skladiste sklad, int minVr, int maxVr) 
    { this (sklad, minVr, maxVr, null); }
  public Potrosac (Skladiste sklad) 
    { this (sklad, 1000, 2000); }
  public void run () {
    while (true) {
      int vredn = skladiste.uzmi ();
      if (polje != null) polje.pisi (id*100000+vredn);
      long vreme = (long)(minVreme + Math.random() * (maxVreme-minVreme));
      try { Thread.sleep (vreme); } catch (InterruptedException e) {}
    }
  }
} // class Potrosac
