// Proizvodjac.java - Klasa za proizvodjace.

package skladista;
import usluge.Polje; // Veza sa grafickom povrsom.

public class Proizvodjac extends Thread {

  private static volatile int ukId = 0;
  private Skladiste skladiste;
  private int id=++ukId, minVreme, maxVreme, broj;
  private Polje polje;

  public Proizvodjac (Skladiste sklad,
    int minVr, int maxVr, Polje p) { 
    minVreme = minVr; maxVreme = maxVr; 
    skladiste = sklad; polje = p;
  }
  public Proizvodjac (Skladiste sklad, int minVr, int maxVr) 
    { this (sklad, minVr, maxVr, null); }
  public Proizvodjac (Skladiste sklad) 
    { this (sklad, 1000, 2000); }
  public void run () {
    while (true) {
      long vreme = (long)(minVreme + Math.random() * (maxVreme-minVreme));
      try { Thread.sleep (vreme); } catch (InterruptedException g) {}
      int vredn = id*1000 + ++broj; 
      skladiste.stavi (vredn);
      if (polje != null) polje.pisi (vredn);
    }
  }
} // class Proizvodjac